



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>bzoj2800</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">bzoj2800</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 23:03:22 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>这题好难，翻了一下波兰文的题解&hellip;&hellip;这好像是当年唯一没人A的题目</p>
<p>首先区间修改不难想到差分，我们令d1=x1，dn+1=-xn，di=xi-xi-1</p>
<p>注意&Sigma;di=0，这样对于[l,r]的修改（比如+a) 就是d[l]+a d[r+1]-a</p>
<p>首先不难想到，对于每个di，ax+by=di一定要有解（gcd(a,b)|di)</p>
<p>这样我们知道这个方程的解为xi=x0+kb yi=y0-ka （x0,y0为这个方程一组解，可以由扩展欧几里德得到）</p>
<p>现在我们考虑最终的答案要求是&Sigma;xi=0&nbsp;&Sigma;yi=0且(|&Sigma;xi|+|&Sigma;yi|)/2最小</p>
<p>我们有这样一个思路，先求出每个f(i)=|xi|+|yi|的最小值，最后总体贪心，调整成&Sigma;xi=0&nbsp;&Sigma;yi=0</p>
<p>f(i)=|x0+kb|+|y0-ka|这显然是凸函数，我们可以用三分来解决</p>
<p>注意ax0+by0=di&nbsp;&Sigma;di=0,所以我们只要&Sigma;ki=0就满足&Sigma;xi=0&nbsp;&Sigma;yi=0</p>
<p>设当前s=|&Sigma;ki|,我们只要用堆调整s次即可得到满足条件的最优值</p>
<p>（关于s的规模不大会证，但跑得很快是了）</p>
<div>
<div>
<pre class="prettyprint linenums"> type node=record<br />
        loc:longint;<br />
        num:int64;<br />
      end;

 var h:array[..] of node;<br />
     x,y:array[..] of int64;<br />
     d:array[..] of longint;<br />
     g,i,j,a,b,n,x0,y0:longint;<br />
     ans,l,m,r,s:int64;

 procedure swap(var a,b:int64);<br />
   var c:int64;<br />
   begin<br />
     c:=a;<br />
     a:=b;<br />
     b:=c;<br />
   end;

 function gcd(a,b:longint):longint;<br />
   begin<br />
     if b= then exit(a)<br />
     else exit(gcd(b,a mod b));<br />
   end;

 function cal(x,y,k:int64):int64;<br />
   begin<br />
     exit(abs(x+k*int64(b))+abs(y-k*int64(a)));<br />
   end;

 procedure exgcd(a,b:longint; var x,y:longint);<br />
   var xx,yy:longint;<br />
   begin<br />
     if b= then<br />
     begin<br />
       x:=;<br />
       y:=;<br />
     end<br />
     else begin<br />
       exgcd(b,a mod b,x,y);<br />
       xx:=x;<br />
       yy:=y;<br />
       x:=yy;<br />
       y:=xx-a div b*yy;<br />
     end;<br />
   end;

 procedure sift(i:longint);<br />
   var j:longint;<br />
       x:node;<br />
   begin<br />
     j:=i shl ;<br />
     while j&lt;=n do<br />
     begin<br />
       if (j&lt;n) and (h[j].num&gt;h[j+].num) then inc(j);<br />
       if h[i].num&gt;h[j].num then<br />
       begin<br />
         x:=h[i]; h[i]:=h[j]; h[j]:=x;<br />
         i:=j;<br />
         j:=j shl ;<br />
       end<br />
       else break;<br />
     end;<br />
   end;

 begin<br />
   readln(n,a,b);<br />
   g:=gcd(a,b);<br />
   for i:= to n do<br />
   begin<br />
     read(d[i]);<br />
     if d[i] mod g&lt;&gt; then<br />
     begin<br />
       writeln(-);<br />
       halt;<br />
     end;<br />
     d[i]:=d[i] div g;<br />
   end;<br />
   a:=a div g; b:=b div g;<br />
   d[n+]:=-d[n];<br />
   for i:=n downto  do<br />
     d[i]:=d[i]-d[i-];<br />
   inc(n);<br />
   if a=b then<br />
   begin<br />
     for i:= to n do<br />
       ans:=ans+abs(d[i]);<br />
     writeln(ans div );<br />
     halt;<br />
   end;<br />
   exgcd(a,b,x0,y0);<br />
   for i:= to n do<br />
   begin<br />
     x[i]:=int64(x0)*int64(d[i]);<br />
     y[i]:=int64(y0)*int64(d[i]);<br />
   //  writeln(x[i],' ',y[i],' ',d[i],':');<br />
     l:=-d[i];<br />
     r:=d[i];<br />
     if l&gt;r then swap(l,r);<br />
     while l+&lt;r do<br />
     begin<br />
       m:=(r-l+) div ;<br />
       if cal(x[i],y[i],l+m)&gt;cal(x[i],y[i],l+*m) then l:=l+m+<br />
       else r:=l+*m-;<br />
     end;<br />
     if cal(x[i],y[i],l)&gt;cal(x[i],y[i],r) then<br />
     begin<br />
       x[i]:=x[i]+r*int64(b);<br />
       y[i]:=y[i]-r*int64(a);<br />
       s:=s+r;<br />
     end<br />
     else begin<br />
       x[i]:=x[i]+l*int64(b);<br />
       y[i]:=y[i]-l*int64(a);<br />
       s:=s+l;<br />
     end;<br />
   //  writeln(x[i],' ',y[i],' ',i,' ',d[i]);<br />
   end;<br />
   if s&lt; then<br />
   begin<br />
     for i:= to n do<br />
       swap(x[i],y[i]);<br />
     g:=a; a:=b; b:=g;<br />
     s:=abs(s);<br />
   end;<br />
   for i:= to n do<br />
   begin<br />
     h[i].loc:=i;<br />
     h[i].num:=abs(x[i]-b)+abs(y[i]+a)-abs(x[i])-abs(y[i]);<br />
   end;<br />
   for i:=n div  downto  do<br />
     sift(i);

   for i:= to s do<br />
   begin<br />
     j:=h[].loc;<br />
     x[j]:=x[j]-b;<br />
     y[j]:=y[j]+a;<br />
     h[].num:=abs(x[j]-b)+abs(y[j]+a)-abs(x[j])-abs(y[j]);<br />
     sift();<br />
   end;<br />
   for i:= to n do<br />
     ans:=ans+abs(x[i])+abs(y[i]);<br />
   writeln(ans div );<br />
 end.</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/eoqv6x8x.html">JavaScript 中的数据类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jr1lq5.html">Vue&period;js入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqldw469.html">【java基础】面向过程~面向对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kydj69.html">XP明年就被停止技术支持，这会带来什么？谈谈如何做决策</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvry5oq.html">经典K线组合图解 &amp;gt&semi; 正文</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmde2e9.html">usaco 土地并购 &amp;amp&semi;&amp;amp&semi; hdu 玩具装箱</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wpwl3q.html">详细介绍如何使用kindEditor编辑器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzzw7g8.html">内存四个领域，变量声明和定义，注册，c内联汇编，auto&comma;堆，不变，静态变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdmvld9.html">nextSibling，previousSibling，childNodes常见错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k52w69.html">apicloud教程1 （转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1klj509.html">简单的3D图片轮播dome</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzd3zg8.html">已知前序（后序）遍历序列和中序遍历序列构建二叉树（Leetcode相关题目）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp7md39.html">html元素禁用disable or enable</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp67o0q.html">Qt3D 5&period;9 and future</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo55gvq.html">OGG 18&period;1 for mysql远程捕获测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rjyk28.html">1283&colon; 骨牌铺方格（zzuli）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj7x6l9.html">Could not allocate 40960 bytes percpu data</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vmgo5q.html">python的logging日志模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjpe2zq.html">Jenkins部署在Tomcat容器提示：反向代理设置有误</a>
		</li>
						<li><a href="https://www.batexi.com/a/963p3rj9.html">DELPHI实现关机，兼容全部WINDOWS系统  转</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8e1j02e9.html">android中设置Animation 动画效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w2xvvq.html">adb shell 出现 error ：</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xwml08.html">md RAID</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1vn779.html">protocol buffer 整数序列化</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mgnd1q.html">在一个长度为n的数组里的所有数字都在0到n-1的范围内。 数组中某些数字是重复的，但不知道有几个数字是重复的。也不知道每个数字重复几次。请找出数组中任意一个重复的数字。 例如，如果输入长度为7的数组&lbrace;2&comma;3&comma;1&comma;0&comma;2&comma;5&comma;3&rcub;，那么对应的输出是重复的数字2或者3</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zljn59.html">HTML5网页制作教程&colon;HTML5块级链接</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zllv69.html">ajax与jsonp的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w22roq.html">PE文件结构详解（四）PE导入表</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvrjvxq.html">XML注入介绍--XXE，XEE&comma;xpath等</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvrj3jq.html">C&plus;&plus;编写Config类读取配置文件</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
